--
-- Hydraulico
--
-- @TMP
-- @31/05/2017

Hydraulico = {};

Hydraulico.modDir = g_currentModDirectory;

function Hydraulico.prerequisitesPresent(specializations)
    return true; 
end;

function Hydraulico:load(savegame)

    self.AnimacaoHydraulico = SpecializationUtil.callSpecializationsFunction("AnimacaoHydraulico"); 
    
    self.Hydraulico = {};
    
    local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.Hydraulico#trigger")) );
    if trigger == nil then
        print("[Erro: Hydraulico] index ok, mas o trigger nas esta localizado. Volte a ver a linha "..tostring(i+1).." no seu xml");
    end;
    
    local TS = getXMLInt(self.xmlFile, string.format("vehicle.Hydraulico#IC_Numero", i));
    
    self.Hydraulico.TS = TS;
    self.Hydraulico.trigger = trigger;
    self.Hydraulico.TMP = false;
        
    addTrigger( trigger, "AnimacaoHydraulico", self );
    
end;

function Hydraulico:delete()
    if self.Hydraulico.trigger ~= nil then
        removeTrigger(self.Hydraulico.trigger);
    end;
end;

function Hydraulico:readStream(streamId, connection)
end;

function Hydraulico:writeStream(streamId, connection)
end;

function Hydraulico:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Hydraulico:keyEvent(unicode, sym, modifier, isDown)
end;

function Hydraulico:update(dt)
    
    if self.Hydraulico.TMP then
        g_currentMission:addHelpButtonText( g_i18n:getText("Hydraulico"), InputBinding.Visibilidade );    
        setTextColor(1.0, 1.0, 1.0, 1.0);
        setTextAlignment(RenderText.ALIGN_CENTER);                 
        renderText( 0.53, 0.045, 0.035, g_i18n:getText("Hydraulico") );
        if InputBinding.hasEvent(InputBinding.Visibilidade)then
            local obj = self.interactiveObjects[self.Hydraulico.TS];
            if obj ~= nil then
                self:doActionOnObject(self.Hydraulico.TS);
            end;
        end
    end;
end;

function Hydraulico:onLeave()
end;

function Hydraulico:draw()
end;

function Hydraulico:AnimacaoHydraulico(triggerId, otherId, onEnter, onLeave, onStay)
    
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.Hydraulico.TMP = true;
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.Hydraulico.TMP = false;
    end;
    
end;