----------------------------------------------------------------------------------------------------------------------
-- @date:         Initial Release Unknown
-- @history:     Unknown
-- @author:        Unknown
-- @version:     1.4     --     EditDate 03.06.2017 Edit by Marc-Modding & Blacky_BPG
-- @version:     1.3a     --     Convert to FS17 / EditDate 27.05.2017 Edit by Marc-Modding & Blacky_BPG
-- @version:     1.1     --     Convert to FS15 / EditDate 20.02.2016 Edit by Marc-Modding & Blacky_BPG
--
----------------------------------------------------------------------------------------------------------------------
--
--MODDESC Entries:
--<specialization name="LuefterSound"             className="LuefterSound"             filename="XXX/LuefterSound.lua"/>
--<vehicleTypes> 
--<type name="XXX" className="" filename="$dataS/scripts/vehicles/Vehicle.lua"> 
--<specialization name="LuefterSound"/> 
--</type> 
--</vehicleTypes>
--
--
--XML Entries:    
--<fanSound file="" pitchOffset="" volume="" radius="" innerRadius=""/>
--
----------------------------------------------------------------------------------------------------------------------


LuefterSound = {}
LuefterSound.modDir = g_currentModDirectory

function LuefterSound.prerequisitesPresent(specializations) return true end

function LuefterSound:load(savegame)
      local fanSound = getXMLString(self.xmlFile, "vehicle.fanSound#file")
        if fanSound ~= nil and fanSound ~= "" then
            fanSound = Utils.getFilename(fanSound, self.baseDirectory)
            self.fanSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fanSound", nil, LuefterSound.modDir, self.components[1].node)
            self.fanSoundVolume = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.fanSound#volume"), 0.5) --Lautstaerke des Soundfiles wenn nicht in XML definiert
            self.fanSoundTime = 29999 --Laenge des FanSoundFiles in ms
            self.startTime = 1
            self.startTimeDiff = 10000 --Dauer bis das Soundfile agespielt wird
            self.stopTime = 0
            self.fanSoundEnabled = false
      end
end

function LuefterSound:delete()         
     if self.fanSound ~= nil then
        SoundUtil.deleteSample(self.fanSound)
    end  
end

function LuefterSound:update(dt)     
    if self.isMotorStarted then 
         if self:getIsActiveForSound() then 
            if self.fanSound ~= nil then
                if self.fanSoundEnabled then
                    self.stopTime = self.stopTime - dt
                    if self.stopTime <= 0 then
                        SoundUtil.stopSample(self.fanSound, true)
                        self.fanSoundEnabled = false
                    end
                end
                if not self.fanSoundEnabled and self.startTime < 1 then
                    SoundUtil.playSample(self.fanSound,0,0,self.fanSoundVolume)
                    self.stopTime = self.fanSoundTime
                    self.fanSoundEnabled = true
                end
            end
        end
    else
-- Nachlauffunktion des Lfters
-- wenn der Motor aus ist und der Lfter luft dann wird dieser nach der normalen Zeit erst abgeschaltet
         if self:getIsActiveForSound() then 
            if self.fanSound ~= nil then
                if self.fanSoundEnabled then
                    self.stopTime = self.stopTime - dt
                    if self.stopTime <= 0 then
                        SoundUtil.stopSample(self.fanSound, true)
                        self.fanSoundEnabled = false
                    end
                end
            end
        end
    end
end

function LuefterSound:updateTick(dt)
    if self.isMotorStarted then
        if self.fanSound ~= nil then
--[[
Abfrage Motorlast
    - wir fragen die Motorlast ab, wollen aber das er zumindest ein wenig Last bekommt auch wenn er steht und nichts tut
        deshalb die math.max Funktion mit nem Mindestwert von 0.25
    
    - im Anschlu multiplizieren wir die Motorlast nochmal mit sich selbst bevor wir sie zur Zeit addieren
        auch hier wieder mit nem Mindestwert von 0.25 (hier: mLoad) weil 0.25 * 0.25 sind 0.0625, da ist der Anstieg zu gering
        - bei 0,5 Motorlast wren das dann 0.25 zum hochzhlen, bei 1,2 Motorlast sind wir damit schon bei 1.44 und
            wie bei dem Drescher hier im Normalfall bei Maximallast von 1,52 wird dann bereits 2.31 addiert
        - so ist der addierte Anstieg steiler als die tatschliche Motorlast und im Leerlauf bzw bei niedriger Last
            springt der Lfter wenigstens nicht andauernd an
        - man kann das Ganze auch noch weiter treiben, mit der auskommentierten Zeile, da hat er als Mindestwert
            natrlich auch wieder die 0.25 aber die anderen Werte variieren natrlich noch weitaus mehr durch die 3fache Multiplikation
            -     0,5  Motorlast = 0.125 Addition (trifft nicht zu da 0.25 Mindestwert, erst ab 0,63 Motorlast gehts los)
                1,2  Motorlast = 1.728 Addition
                1,52 Motorlast = 3.512 Addition
--]]
            local mLoad = math.max(self.motor:getMotorLoad(),0.25)
            self.startTime = self.startTime + math.max((mLoad*mLoad),mLoad)
            -- self.startTime = self.startTime + math.max((mLoad*mLoad*mLoad),mLoad)
            if self.startTime > self.startTimeDiff then
                self.startTime = 0
            end
        end
    end
end

function LuefterSound:stopSounds()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.stopSample(self.fanSound, true)
              self.fanSoundEnabled = false
         end
    end
end
function LuefterSound:onEnter()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.playSample(self.fanSound,0,0,self.fanSoundVolume)
         end
    end
end
function LuefterSound:onLeave()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.stopSample(self.fanSound, true)
         end
    end
end

function LuefterSound:startMotor() end
function LuefterSound:stopMotor() end
function LuefterSound:mouseEvent(posX, posY, isDown, isUp, button) end
function LuefterSound:keyEvent(unicode, sym, modifier, isDown) end
function LuefterSound:draw() end





DisplayBoot = {}
DisplayBoot.modDir = g_currentModDirectory
function DisplayBoot.prerequisitesPresent(specializations) return true end
function DisplayBoot:load(savegame)
    self.speedWaitingMaxTimeHud = 1400
    self.speedWaitingTimerBoot = 0
    self.bootScreen = 1
    local bootTime = 0
    if hasXMLProperty(self.xmlFile,"vehicle.bootLoader") then
        self.bootLoader = {}
        self.speedWaitingMaxTimeHud = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.bootLoader#defaultTime"),self.speedWaitingMaxTimeHud)
        local i = 0;
        while true do
            local key = string.format("vehicle.bootLoader.screen(%d)",i)
            if not hasXMLProperty(self.xmlFile, key) then
                break
            end
            i = i + 1
            self.bootLoader[i] = {}
            self.bootLoader[i].wasSet = false
            self.bootLoader[i].time = math.max(Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#showTime"),self.speedWaitingMaxTimeHud),60) + bootTime
            self.bootLoader[i].stayOn = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#stayOn"),false)
            bootTime = self.bootLoader[i].time
            local screen = getXMLString(self.xmlFile, key.."#index")
            if screen ~= nil then
                self.bootLoader[i].screen = Utils.indexToObject(self.components, screen)
                setVisibility(self.bootLoader[i].screen, false)
            end
            local other = getXMLString(self.xmlFile, key.."#other")
            if other ~= nil then
                self.bootLoader[i].other = Utils.indexToObject(self.components, other)
                setVisibility(self.bootLoader[i].other, false)
            end
            local sound = getXMLString(self.xmlFile, key.."#sound")
            if sound ~= nil then
                self.bootLoader[i].sound = Utils.indexToObject(self.components, sound)
                setVisibility(self.bootLoader[i].sound, false)
            end
            local soundFile = getXMLString(self.xmlFile, key.."#soundFile")
            if soundFile ~= nil then
                self.bootLoader[i].soundSample = createSample("screen"..i.."Sample")
                local fileName = Utils.getFilename(soundFile, DisplayBoot.modDir)
                loadSample(self.bootLoader[i].soundSample, fileName, false)
            end
        end
    end
end

function DisplayBoot:update(dt)
    if self.isMotorStarted then
        if self.bootLoader ~= nil then
            if self.bootLoader[self.bootScreen] ~= nil then
                if self.speedWaitingTimerBoot < self.bootLoader[self.bootScreen].time then
                    if not self.bootLoader[self.bootScreen].wasSet then
                        if self.bootLoader[self.bootScreen].screen ~= nil then
                            setVisibility(self.bootLoader[self.bootScreen].screen, true)
                        end
                        if self.bootLoader[self.bootScreen].other ~= nil then
                            setVisibility(self.bootLoader[self.bootScreen].other, true)
                        end
                        if g_currentMission.controlledVehicle == self and self.activeCamera.isInside then
                            if self.bootLoader[self.bootScreen].sound ~= nil then
                                setVisibility(self.bootLoader[self.bootScreen].sound, true)
                            end
                            if self.bootLoader[self.bootScreen].soundSample ~= nil then
                                playSample(self.bootLoader[self.bootScreen].soundSample, 1, 1, 0)
                            end
                        end
                        self.bootLoader[self.bootScreen].wasSet = true
                    end
                else
                    if self.speedWaitingTimerBoot >= self.bootLoader[self.bootScreen].time then
                        if self.bootLoader[self.bootScreen].wasSet then
                            if not self.bootLoader[self.bootScreen].stayOn then
                                if self.bootLoader[self.bootScreen].screen ~= nil then
                                    setVisibility(self.bootLoader[self.bootScreen].screen, false)
                                end
                                if self.bootLoader[self.bootScreen].other ~= nil then
                                    setVisibility(self.bootLoader[self.bootScreen].other, false)
                                end
                                if self.bootLoader[self.bootScreen].sound ~= nil then
                                    setVisibility(self.bootLoader[self.bootScreen].sound, false)
                                end
                                if self.bootLoader[self.bootScreen].soundSample ~= nil then
                                    stopSample(self.bootLoader[self.bootScreen].soundSample)
                                end
                            end
                            self.bootLoader[self.bootScreen].wasSet = false
                        end
                        self.bootScreen = self.bootScreen + 1
                    end
                end
            end
        end
        self.speedWaitingTimerBoot = self.speedWaitingTimerBoot + dt
    else
        for i=1, table.getn(self.bootLoader) do
            if self.bootLoader[i] ~= nil then
                if self.bootLoader[i].screen ~= nil then
                    setVisibility(self.bootLoader[i].screen, false)
                end
                if self.bootLoader[i].other ~= nil then
                    setVisibility(self.bootLoader[i].other, false)
                end
                if self.bootLoader[i].sound ~= nil then
                    setVisibility(self.bootLoader[i].sound, false)
                end
                if self.bootLoader[i].soundSample ~= nil then
                    stopSample(self.bootLoader[i].soundSample)
                end
                self.bootLoader[i].wasSet = false
            end
        end
        self.speedWaitingTimerBoot = 0
        self.bootScreen = 1
    end
end

function DisplayBoot:delete()
    if self.bootLoader ~= nil then
        for i=1, table.getn(self.bootLoader) do
            if self.bootLoader[i] ~= nil and self.bootLoader[i].soundSample ~= nil then
                stopSample(self.bootLoader[i].soundSample)
                delete(self.bootLoader[i].soundSample)
            end
        end
    end
end

function DisplayBoot:getSaveAttributesAndNodes(nodeIdent) end
function DisplayBoot:updateTick(dt) end
function DisplayBoot:draw() end
function DisplayBoot:mouseEvent(posX, posY, isDown, isUp, button) end
function DisplayBoot:keyEvent(unicode, sym, modifier, isDown) end
function DisplayBoot:onAttach(attacherVehicle, jointDescIndex) end
function DisplayBoot:onDetach() end
function DisplayBoot:onDeactivate() end







usage = {}
usage.maxValueAnim = 100

function usage.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(Combine, specializations) end

function usage:load(savegame)
    self.currentSpeed = 0
    self.isusage = false
    self.timerI = 0
    self.calcShownActLoad = SpecializationUtil.callSpecializationsFunction("calcShownActLoad")
    self.setShownActLoad = SpecializationUtil.callSpecializationsFunction("setShownActLoad")
    self.setIsBlocked = SpecializationUtil.callSpecializationsFunction("setIsBlocked")
    self.isBlocked = false
    self.blockTimer = 0
    self.blockMaxTime = 2000
    self.usageIndoorHud = VehicleHudUtils.loadHud(self, self.xmlFile, "usageLoad")

    local nodeIndex = getXMLString(self.xmlFile, "vehicle.usageBaseNode#index")
    local usageBaseNode
    if nodeIndex==nil then
        usageBaseNode = self.components[1].node
    else
        usageBaseNode = Utils.indexToObject(self.components, nodeIndex)
    end
    self.maximalWidth = 0
    self.currentWidth = 0
    self.pucleanNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.usage#cleanNode"))
    self.lastFillChangeTime = 0
    self.currentActLoad = 0
    self.showActLoad = 0
    self.lastFillLevelDelta = 0
    self.currentStep = 1
    self.timeSinceLastLoad = 0
    self.time = 0
    self.maxLoad = 30
    self.lastDeltaFill = 0
    self.fillLevel1 = 0
    self.fillLevel2 = 0
    self.soundPlayed = false
    self.soundTimer = 0
    self.lastActLoad = 0
    self.fillingDeltas = {}
    self.lastAreaForCalc = 0
    
    local uiScale = g_uiScale
    if g_gameSettings ~= nil then
        uiScale = g_gameSettings:getValue("uiScale")
    end

    self.hud2 = {}
    local width, height = getNormalizedScreenValues(225*uiScale, 20*uiScale)
    local w, h = getNormalizedScreenValues(0, 160*uiScale)
    self.hud2.xPos = 1-g_safeFrameOffsetX-width
    self.hud2.yPos = h+g_safeFrameOffsetY
    self.hud2.hudWidth = width
    self.hud2.overlay_hud     = Overlay:new("loadHUD_hud", Utils.getFilename("shared/hud_block.dds", self.baseDirectory), self.hud2.xPos, self.hud2.yPos, width, height)
    self.hud2.overlay_bar     = Overlay:new("loadHUD_bar", Utils.getFilename("shared/hud_barY.dds", self.baseDirectory), self.hud2.xPos, self.hud2.yPos, width, height)
    self.getIsAreaActive = Utils.overwrittenFunction(self.getIsAreaActive, Combine.getIsAreaActive)
    
    if self.isClient then
        self.sampleUsageWarning = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.usageWarningSound", nil, self.baseDirectory, self.components[1].node)
    end
end

function usage:mouseEvent(posX, posY, isDown, isUp, button)
end

function usage:keyEvent(unicode, sym, modifier, isDown)
end

function usage:update(dt)
    if self.isBlocked and self:getIsTurnedOn() then
        self:setIsTurnedOn(false)
    end
    if g_currentMission.player ~= nil then
        local pvx, pvy, pvz = getWorldTranslation(g_currentMission.player.rootNode)
        local px, py, pz = getWorldTranslation(self.pucleanNode)
        local distance = Utils.vector3Length(px-pvx, py-pvy, pz-pvz)
        if distance < 2.5 then
            if self.isBlocked then
                g_currentMission:addHelpButtonText( g_i18n:getText("CONVEYOR_CLEAN"), InputBinding.IMPLEMENT_EXTRA, nil, GS_PRIO_NORMAL)
                if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
                    self:setIsBlocked(false)
                end
            end
        end
    end
end
 
function usage:readUpdateStream(streamId, timestamp, connection) 
    if connection:getIsServer() then 
        self.lastAreaForCalc = streamReadFloat32(streamId)
    end
end
 
function usage:writeUpdateStream(streamId, connection, dirtyMask) 
    if not connection:getIsServer() then 
        streamWriteFloat32(streamId, self.lastAreaForCalc)
    end
end

function usage:updateTick(dt)
    if not self.isAIThreshing and not (self.cp ~= nil and self.cp.isDriving ) then
        if self.combineIsFilling then

            if self.isServer then 
                self.lastAreaForCalc = self.lastArea
            end
            
            if FruitUtil.fruitIndexToDesc[self.lastValidFillType] ~= nil and FruitUtil.fruitIndexToDesc[self.lastValidFillType].literPerSqm ~= nil then
                self.fillingDeltas[self.timerI] = ((self.lastAreaForCalc * g_currentMission:getFruitPixelsToSqm())*FruitUtil.fruitIndexToDesc[self.lastValidFillType].literPerSqm)
            else
                self.fillingDeltas[self.timerI] = ((self.lastAreaForCalc * g_currentMission:getFruitPixelsToSqm())*FruitUtil.fruitIndexToDesc[1].literPerSqm)
            end
            if self.timerI == 20 then
                self.time = 0
                self.timerI = 0
                self.lastFillChangeTime = self.time
                deltaFill = (self.fillLevel1 + self.fillLevel2) / 20
                for k in pairs (self.fillingDeltas) do
                    deltaFill = deltaFill + self.fillingDeltas[k]
                end
                for k in pairs (self.fillingDeltas) do
                    self.fillingDeltas[k] = nil
                end
                
                if self.lastActLoad == deltaFill then
                    self.currentActLoad = deltaFill + 3
                else
                    self.currentActLoad = deltaFill
                end
                self.lastActLoad = self.currentActLoad
            end
        else
            self.time = self.time + dt
            self.lastFillChangeTime = self.time
        end
        if not self.combineIsFilling  then
            self.time = self.time + dt
            self.lastFillChangeTime = self.time
        end
        if (self.lastFillChangeTime > 1100 and self.currentActLoad > 0) then
            self.currentActLoad = 0
        end
        self:calcShownActLoad(self.currentActLoad)
        
        self.currentSpeed = self:getLastSpeed() * self.speedDisplayScale
        
        if self.currentWidth == self.maxLoad and self.currentSpeed > 4 then 
            self.blockTimer = self.blockTimer + dt
            if self.blockTimer > self.blockMaxTime then
                if not self.isBlocked then
                    self.blockTimer = 0
                    self:setIsBlocked(true)
                end
            end
        else
            self.blockTimer = math.max(0, self.blockTimer - dt)
        end
        local percentage = math.min(self.currentWidth/self.maxLoad, 1)
        self.threshingScale = 1-(math.max(0, percentage-0.9)*2)
        if self.isClient then
            if self.isEntered then
                if percentage > 0.92 or self.isBlocked then
                    if self.sampleUsageWarning ~= nil and not self.sampleUsageWarning.isPlaying then
                        SoundUtil.playSample(self.sampleUsageWarning, 0,0,nil)
                    end
                else
                    if self.sampleUsageWarning ~= nil and self.sampleUsageWarning.isPlaying then
                        SoundUtil.stopSample(self.sampleUsageWarning, true)
                    end
                end
            else
                if self.sampleUsageWarning ~= nil and self.sampleUsageWarning.isPlaying then
                    SoundUtil.stopSample(self.sampleUsageWarning, true)
                end
            end
        end
        self.timerI = self.timerI + 1
        if self.timerI > 20 then
            self.timerI = 0
        end
        if self.usageIndoorHud ~= nil then
            if self.isBlocked then             
            percentage = 1          
            end
        VehicleHudUtils.setHudValue(self, self.usageIndoorHud, percentage*usage.maxValueAnim,usage.maxValueAnim)
        end
    else
        self.currentWidth = 0
    end
end

function usage:draw()
    setTextColor(1.0, 1.0, 1.0, 1.0)
    setTextBold(false)
    
    local percentage = math.min(self.currentWidth/self.maxLoad, 1)
    if self.isBlocked then
        percentage = 1
    end
    local red = 0.7
    local green = 1.0
    
    if percentage <= 0.7 then
        green = green - (0.5/0.7*percentage)
        red = red + (0.3/0.7*percentage)
    else
        green = (green/2) - (0.5/0.3*(percentage-0.7))
        red = 1.0
    end
    green = math.max(0,math.min(green,1))
    red = math.max(0,math.min(red,1))
    setOverlayColor(self.hud2.overlay_bar.overlayId, red, green, 0, 1)
    
    self.hud2.overlay_bar.width = self.hud2.hudWidth * percentage
    setOverlayUVs(self.hud2.overlay_bar.overlayId, 0, 0.05, 0, 1, percentage, 0.05, percentage, 1)
    self.hud2.overlay_bar:render()
    
    self.hud2.overlay_hud:render()

    setTextAlignment(RenderText.ALIGN_CENTER)
    local x = 0.043359375
    local y = 0.003500001303852
    
    renderText(self.hud2.xPos+x, self.hud2.yPos+y, 0.009, g_i18n:getText("ACT_LOAD").." "..string.format("%5.2f %%", 100*percentage))
    setTextAlignment(RenderText.ALIGN_LEFT)

    if self.isBlocked then
        g_currentMission:showBlinkingWarning(g_i18n:getText("CONVEYOR_IS_BLOCKED"), 1500)
    end
end

function usage:delete()
end

function usage:setShownActLoad(act, noEventSend)    
    self.currentWidth = math.max(math.min(act, self.maxLoad), 0)
end

function usage:calcShownActLoad(target)
    if target == self.currentWidth then
        return
    end
    
    local step = self.currentStep * math.abs(self.currentWidth-target)/6
    
    if self.lastFillChangeTime > 1000 then
        step = step * 10
    end
    
    if target > self.currentWidth then
        self:setShownActLoad(math.min(self.currentWidth + step, target))
    else
        self:setShownActLoad(math.max(self.currentWidth - step, target))
    end
end

function usage:setIsBlocked(state, noEventSend)
    SetBlockedEvent.sendEvent(self, state, noEventSend)
    self.isBlocked = state
end
-----------------------------------------SetBlocked E V E N T-------------------------------------------------
SetBlockedEvent = {}
SetBlockedEvent_mt = Class(SetBlockedEvent, Event) InitEventClass(SetBlockedEvent, "SetBlockedEvent")

function SetBlockedEvent:emptyNew()
    local self = Event:new(SetBlockedEvent_mt)
    self.className="SetBlockedEvent"
    return self
end

function SetBlockedEvent:new(vehicle, state)
    local self = SetBlockedEvent:emptyNew()
    self.vehicle = vehicle
    self.state = state
    return self
end

function SetBlockedEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId)
    self.state = streamReadBool(streamId)
    self.vehicle = networkGetObject(id)
    self:run(connection)
end

function SetBlockedEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle))
    streamWriteBool(streamId, self.state)
end

function SetBlockedEvent:run(connection)
    self.vehicle:setIsBlocked(self.state, true)
    if not connection:getIsServer() then
        g_server:broadcastEvent(SetBlockedEvent:new(self.vehicle, self.state), nil, connection, self.object)
    end
end

function SetBlockedEvent.sendEvent(vehicle, state, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(SetBlockedEvent:new(vehicle, state), nil, nil, vehicle)
        else
            g_client:getServerConnection():sendEvent(SetBlockedEvent:new(vehicle, state))
        end
    end
end
-----------------------------------------ShownActLoad E V E N T-------------------------------------------------
SetShownActLoadEvent = {}
SetShownActLoadEvent_mt = Class(SetShownActLoadEvent, Event)

InitEventClass(SetShownActLoadEvent, "SetShownActLoadEvent")

function SetShownActLoadEvent:emptyNew()
    local self = Event:new(SetShownActLoadEvent_mt)
    self.className="SetShownActLoadEvent"
    return self
end

function SetShownActLoadEvent:new(vehicle, showActLoad)
    local self = SetShownActLoadEvent:emptyNew()
    self.vehicle = vehicle
    self.showActLoad = showActLoad
    return self
end

function SetShownActLoadEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId)
    self.vehicle = networkGetObject(id)

    self.showActLoad = streamReadFloat32(streamId)
    if self.vehicle ~= nil then
        self.vehicle:setShownActLoad(self.showActLoad, true)
    end
    if not connection:getIsServer() then
        g_server:broadcastEvent(SetShownActLoadEvent:new(self.vehicle, self.showActLoad), nil, connection, self.vehicle)
    end
end

function SetShownActLoadEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle))
    streamWriteFloat32(streamId, self.showActLoad)
end

function SetShownActLoadEvent.sendEvent(vehicle, showActLoad, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(SetShownActLoadEvent:new(vehicle, showActLoad), nil, nil, vehicle)
        else
            g_client:getServerConnection():sendEvent(SetShownActLoadEvent:new(vehicle, showActLoad))
        end
    end
end







LightControls = {}
LightControls.modDir = g_currentModDirectory
function LightControls.prerequisitesPresent(specializations) return true end
function LightControls:load(savegame)
    self.lightControlHud = VehicleHudUtils.loadHud(self, self.xmlFile, "turnlight")
    if self.lightControlHud ~= nil then
        VehicleHudUtils.setHudValue(self, self.lightControlHud, 1, 2)
    end
end

function LightControls:update(dt)
    if self.lightControlHud ~= nil then
        if self.turnLightState ~= Lights.TURNLIGHT_OFF and self.turnLightState ~= Lights.TURNLIGHT_HAZARD then
            if self.turnLightState == Lights.TURNLIGHT_LEFT then
                VehicleHudUtils.setHudValue(self, self.lightControlHud, 0, 2)
            elseif self.turnLightState == Lights.TURNLIGHT_RIGHT then
                VehicleHudUtils.setHudValue(self, self.lightControlHud, 2, 2)
            else
                VehicleHudUtils.setHudValue(self, self.lightControlHud, 1, 2)
            end
        else
            VehicleHudUtils.setHudValue(self, self.lightControlHud, 1, 2)
        end
    end
end
function LightControls:delete() end
function LightControls:getSaveAttributesAndNodes(nodeIdent) end
function LightControls:updateTick(dt) end
function LightControls:draw() end
function LightControls:mouseEvent(posX, posY, isDown, isUp, button) end
function LightControls:keyEvent(unicode, sym, modifier, isDown) end
function LightControls:onAttach(attacherVehicle, jointDescIndex) end
function LightControls:onDetach() end
function LightControls:onDeactivate() end
