-- indoorSounds.lua
--
-- Author Rival
-- 05.01.2016
    
-- TMP @07/10/2017

indoorSounds = {};

function indoorSounds.prerequisitesPresent(specializations)
    return true;
end;

function indoorSounds:load(savegame)       
    self.soundInt = {};
    local i=0;
    while true do
        local key = string.format("vehicle.indoorSounds.animation(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local animName = getXMLString(self.xmlFile, key.."#name");
        local lowpassGain = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#lowpassGain"), 0.5);
        local volumeFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#volumeFactor"), 0.5);
        self.soundInt[i] = {};
        self.soundInt[i].animName = animName;
        self.soundInt[i].volumeFactor = volumeFactor;
        self.soundInt[i].lowpassGain = lowpassGain;
        i = i +1;
    end;
    
    if self.isClient then
        -- Porta Esquerda
        self.sampleAbrirPortaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.abrirPortaSon", "sounds/abrir_porta.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharPortaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fecharPortaSon", "sounds/fechar_porta.wav", self.baseDirectory, self.components[1].node);
        -- Porta Direita
        self.sampleAbrirPortaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.abrirPortaSon", "sounds/abrir_porta.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharPortaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fecharPortaSon", "sounds/fechar_porta.wav", self.baseDirectory, self.components[1].node);
        -- Cortinado hgm
        self.sampleLevantarCortinado = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.levantarCortinadoSon", "sounds/cortinado.wav", self.baseDirectory, self.components[1].node);
        self.sampleBaixarCortinado = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.baixarCortinadoSon", "sounds/cortinado.wav", self.baseDirectory, self.components[1].node);
        -- Janela Esquerda
        self.sampleAbrirJanelaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.abrirJanelaSon", "sounds/abrir_janela.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharJanelaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fecharJanelaSon", "sounds/fechar_janela.wav", self.baseDirectory, self.components[1].node);
        -- Janela Direita
        self.sampleAbrirJanelaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.abrirJanelaSon", "sounds/abrir_janela.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharJanelaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fecharJanelaSon", "sounds/fechar_janela.wav", self.baseDirectory, self.components[1].node);
        -- Janela Tras
        self.sampleAbrirJanelaT = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.abrirJanelaSon", "sounds/abrir_janela2.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharJanelaT = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fecharJanelaSon", "sounds/fechar_janela.wav", self.baseDirectory, self.components[1].node);
        -- Reposa Mao Esquerda
        self.sampleLevantarReposaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.levantarReposaMaoSon", "sounds/seguro_mao_abrir.wav", self.baseDirectory, self.components[1].node);
        self.sampleBaixarReposaE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.baixarReposaMaoSon", "sounds/seguro_mao_fechar.wav", self.baseDirectory, self.components[1].node);
        -- Reposa Mao Direita
        self.sampleLevantarReposaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.levantarReposaMaoSon", "sounds/seguro_mao_abrir.wav", self.baseDirectory, self.components[1].node);
        self.sampleBaixarReposaD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.baixarReposaMaoSon", "sounds/seguro_mao_fechar.wav", self.baseDirectory, self.components[1].node);
        -- Espelho Esquerda
        self.sampleAbrirEspelhoE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.AbrirEspelhoE", "sounds/seguro_mao_abrir.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharEspelhoE = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.FecharEspelhoE", "sounds/TAM.wav", self.baseDirectory, self.components[1].node);
        -- Espelho Direita
        self.sampleAbrirEspelhoD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.AbrirEspelhoD", "sounds/seguro_mao_abrir.wav", self.baseDirectory, self.components[1].node);
        self.sampleFecharEspelhoD = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.FecharEspelhoD", "sounds/TAM.wav", self.baseDirectory, self.components[1].node);
    end;
    
    self.OrigindoorVolumeFactor = self.sampleMotor.indoorVolumeFactor;
    self.OrigindoorLowpassGain = self.sampleMotor.indoorLowpassGain;
    self.OrigindoorVolumeFactor = self.sampleMotorStart.indoorVolumeFactor;
    self.OrigindoorLowpassGain = self.sampleMotorStart.indoorLowpassGain;
    self.OrigindoorVolumeFactor = self.sampleMotorStop.indoorVolumeFactor;
    self.OrigindoorLowpassGain = self.sampleMotorStop.indoorLowpassGain;
    
    self.OrigindoorVolumeFactor = self.sampleMotorRun.indoorVolumeFactor;
    self.OrigindoorLowpassGain = self.sampleMotorRun.indoorLowpassGain;
    self.OrigindoorVolumeFactor = self.sampleMotorLoad.indoorVolumeFactor;
    self.OrigindoorLowpassGain = self.sampleMotorLoad.indoorLowpassGain;
end;
function indoorSounds:delete()
    if self.sampleAbrirPortaE ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirPortaE);
    end;
    if self.sampleAbrirPortaD ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirPortaD);
    end;
    if self.sampleLevantarCortinado ~= nil then
        SoundUtil.deleteSample(self.sampleLevantarCortinado);
    end;
    if self.sampleAbrirJanelaE ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirJanelaE);
    end;
    if self.sampleAbrirJanelaD ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirJanelaD);
    end;
    if self.sampleAbrirJanelaT ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirJanelaT);
    end;
    if self.sampleLevantarReposaE ~= nil then
        SoundUtil.deleteSample(self.sampleLevantarReposaE);
    end;
    if self.sampleLevantarReposaD ~= nil then
        SoundUtil.deleteSample(self.sampleLevantarReposaD);
    end;
    if self.sampleAbrirEspelhoE ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirEspelhoE);
    end;
    if self.sampleAbrirEspelhoD ~= nil then
        SoundUtil.deleteSample(self.sampleAbrirEspelhoD);
    end;
    
    
    
    if self.sampleFecharPortaE ~= nil then
        SoundUtil.deleteSample(self.sampleFecharPortaE);
    end;
    if self.sampleFecharPortaD ~= nil then
        SoundUtil.deleteSample(self.sampleFecharPortaD);
    end;
    if self.sampleBaixarCortinado ~= nil then
        SoundUtil.deleteSample(self.sampleBaixarCortinado);
    end;
    if self.sampleFecharJanelaE ~= nil then
        SoundUtil.deleteSample(self.sampleFecharJanelaE);
    end;
    if self.sampleFecharJanelaD ~= nil then
        SoundUtil.deleteSample(self.sampleFecharJanelaD);
    end;
    if self.sampleFecharJanelaT ~= nil then
        SoundUtil.deleteSample(self.sampleFecharJanelaT);
    end;
    if self.sampleBaixarReposaE ~= nil then
        SoundUtil.deleteSample(self.sampleBaixarReposaE);
    end;
    if self.sampleBaixarReposaD ~= nil then
        SoundUtil.deleteSample(self.sampleBaixarReposaD);
    end;
    if self.sampleFecharEspelhoE ~= nil then
        SoundUtil.deleteSample(self.sampleFecharEspelhoE);
    end;
    if self.sampleFecharEspelhoD ~= nil then
        SoundUtil.deleteSample(self.sampleFecharEspelhoD);
    end;
end;
function indoorSounds:mouseEvent(posX, posY, isDown, isUp, button)
end;
function indoorSounds:keyEvent(unicode, sym, modifier, isDown)
end;
function indoorSounds:update(dt)
    if self:getIsActive() and self.isClient then        
        if self.isEntered then
            if self:getIsAnimationPlaying("PortaEsquerda") and self:getIsActiveForSound() then
                if self.animations["PortaEsquerda"].currentSpeed > 0 and self.animations["PortaEsquerda"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirPortaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirPortaE,1,1,nil);
                    end;
                elseif self.animations["PortaEsquerda"].currentSpeed < 0 and self.animations["PortaEsquerda"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharPortaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharPortaE,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("PortaDireita") and self:getIsActiveForSound() then
                if self.animations["PortaDireita"].currentSpeed > 0 and self.animations["PortaDireita"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirPortaD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirPortaD,1,1,nil);
                    end;
                elseif self.animations["PortaDireita"].currentSpeed < 0 and self.animations["PortaDireita"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharPortaD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharPortaD,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("Cortinado") and self:getIsActiveForSound() then
                if self.animations["Cortinado"].currentSpeed > 0 and self.animations["Cortinado"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleLevantarCortinado, 1.5*dt) then
                        SoundUtil.playSample(self.sampleLevantarCortinado,1,1,nil);
                    end;
                elseif self.animations["Cortinado"].currentSpeed < 0 and self.animations["Cortinado"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleBaixarCortinado, 1.5*dt) then
                        SoundUtil.playSample(self.sampleBaixarCortinado,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("JanelaEsquerda") and self:getIsActiveForSound() then
                if self.animations["JanelaEsquerda"].currentSpeed > 0 and self.animations["JanelaEsquerda"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirJanelaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirJanelaE,1,1,nil);
                    end;
                elseif self.animations["JanelaEsquerda"].currentSpeed < 0 and self.animations["JanelaEsquerda"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharJanelaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharJanelaE,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("JanelaDireita") and self:getIsActiveForSound() then
                if self.animations["JanelaDireita"].currentSpeed > 0 and self.animations["JanelaDireita"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirJanelaD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirJanelaD,1,1,nil);
                    end;
                elseif self.animations["JanelaDireita"].currentSpeed < 0 and self.animations["JanelaDireita"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharJanelaD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharJanelaD,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("JanelaTras") and self:getIsActiveForSound() then
                if self.animations["JanelaTras"].currentSpeed > 0 and self.animations["JanelaTras"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirJanelaT, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirJanelaT,1,1,nil);
                    end;
                elseif self.animations["JanelaTras"].currentSpeed < 0 and self.animations["JanelaTras"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharJanelaT, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharJanelaT,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("ReposaEsquerdo") and self:getIsActiveForSound() then
                if self.animations["ReposaEsquerdo"].currentSpeed > 0 and self.animations["ReposaEsquerdo"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleLevantarReposaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleLevantarReposaE,1,1,nil);
                    end;
                elseif self.animations["ReposaEsquerdo"].currentSpeed < 0 and self.animations["ReposaEsquerdo"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleBaixarReposaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleBaixarReposaE,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("ReposaDireito") and self:getIsActiveForSound() then
                if self.animations["ReposaDireito"].currentSpeed > 0 and self.animations["ReposaDireito"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleLevantarReposaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleLevantarReposaE,1,1,nil);
                    end;
                elseif self.animations["ReposaDireito"].currentSpeed < 0 and self.animations["ReposaDireito"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleBaixarReposaE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleBaixarReposaE,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("EspelhoEsquerda") and self:getIsActiveForSound() then
                if self.animations["EspelhoEsquerda"].currentSpeed > 0 and self.animations["EspelhoEsquerda"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirEspelhoE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirEspelhoE,1,1,nil);
                    end;
                elseif self.animations["EspelhoEsquerda"].currentSpeed < 0 and self.animations["EspelhoEsquerda"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharEspelhoE, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharEspelhoE,1,1,nil);
                    end;
                end;
            end;
            if self:getIsAnimationPlaying("EspelhoDireita") and self:getIsActiveForSound() then
                if self.animations["EspelhoDireita"].currentSpeed > 0 and self.animations["EspelhoDireita"].currentTime < 50 then
                    if not SoundUtil.isSamplePlaying(self.sampleAbrirEspelhoD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleAbrirEspelhoD,1,1,nil);
                    end;
                elseif self.animations["EspelhoDireita"].currentSpeed < 0 and self.animations["EspelhoDireita"].currentTime < 100 then
                    if not SoundUtil.isSamplePlaying(self.sampleFecharEspelhoD, 1.5*dt) then
                        SoundUtil.playSample(self.sampleFecharEspelhoD,1,1,nil);
                    end;
                end;
            end;
            local sound=false;
            for i=0, #self.soundInt do
                if self.animations[self.soundInt[i].animName] ~= nil and self.animations[self.soundInt[i].animName].currentTime > 500 then
                    self.sampleMotor.indoorVolumeFactor = math.max(self.soundInt[i].volumeFactor, self.sampleMotor.indoorVolumeFactor);
                    self.sampleMotor.indoorLowpassGain = math.max(self.soundInt[i].lowpassGain, self.sampleMotor.indoorLowpassGain);
                    self.sampleMotorStart.indoorVolumeFactor = math.max(self.soundInt[i].volumeFactor, self.sampleMotorStart.indoorVolumeFactor);
                    self.sampleMotorStart.indoorLowpassGain = math.max(self.soundInt[i].lowpassGain, self.sampleMotorStart.indoorLowpassGain);
                    self.sampleMotorStop.indoorVolumeFactor = math.max(self.soundInt[i].volumeFactor, self.sampleMotorStop.indoorVolumeFactor);
                    self.sampleMotorStop.indoorLowpassGain = math.max(self.soundInt[i].lowpassGain, self.sampleMotorStop.indoorLowpassGain);
                    
                    self.sampleMotorRun.indoorVolumeFactor = math.max(self.soundInt[i].volumeFactor, self.sampleMotorRun.indoorVolumeFactor);
                    self.sampleMotorRun.indoorLowpassGain = math.max(self.soundInt[i].lowpassGain, self.sampleMotorRun.indoorLowpassGain);
                    self.sampleMotorLoad.indoorVolumeFactor = math.max(self.soundInt[i].volumeFactor, self.sampleMotorLoad.indoorVolumeFactor);
                    self.sampleMotorLoad.indoorLowpassGain = math.max(self.soundInt[i].lowpassGain, self.sampleMotorLoad.indoorLowpassGain);
                    sound=true;
                else
                    if not sound then
                        self.sampleMotor.indoorVolumeFactor = self.OrigindoorVolumeFactor;
                        self.sampleMotor.indoorLowpassGain = self.OrigindoorLowpassGain;
                        self.sampleMotorStart.indoorVolumeFactor = self.OrigindoorVolumeFactor;
                        self.sampleMotorStart.indoorLowpassGain = self.OrigindoorLowpassGain;
                        self.sampleMotorStop.indoorVolumeFactor = self.OrigindoorVolumeFactor;
                        self.sampleMotorStop.indoorLowpassGain = self.OrigindoorLowpassGain;
                        
                        self.sampleMotorRun.indoorVolumeFactor = self.OrigindoorVolumeFactor;
                        self.sampleMotorRun.indoorLowpassGain = self.OrigindoorLowpassGain;
                        self.sampleMotorLoad.indoorVolumeFactor = self.OrigindoorVolumeFactor;
                        self.sampleMotorLoad.indoorLowpassGain = self.OrigindoorLowpassGain;
                    end;
                end;
            end;
            SoundUtil.onCameraSwitched(self.activeCamera.isInside);
        end;
    end;
end;
function indoorSounds:updateTick(dt)
end;
function indoorSounds:draw()    
end;